Bug 69521 - problems with repackaged rpms (rpm reports size mismatch + "No signature available")
problems with repackaged rpms (rpm reports size mismatch + "No signature avai...
Product: Red Hat Public Beta
Classification: Retired
Component: rpm (Show other bugs)
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Jeff Johnson
: 69519 (view as bug list)
Depends On:
Blocks: 67217
  Show dependency treegraph
Reported: 2002-07-22 18:42 EDT by Michael Schwendt
Modified: 2008-05-01 11:38 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2002-07-22 23:31:35 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Michael Schwendt 2002-07-22 18:42:07 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.0.1) Gecko/20020712

Description of problem:
Also see intro to bug #69211.

Limbo's version of up2date repackages installed rpms in /var/spool/up2date (as
configured in /usr/lib/rpm/macros). On Limbo, with rpm-4.1-0.34 or 4.1-0.50,
these packages _cannot_ be queried. E.g.

# rpm -qpl xinetd-2.3.5-3.i386.rpm 
warning: Expected size:       209735 = lead(96)+sigs(344)+pad(0)+data(209295)
warning:   Actual size:       209746
error: xinetd-2.3.5-3.i386.rpm: No signature available
error: query of xinetd-2.3.5-3.i386.rpm failed

# rpm -qpl xmlto-0.0.10-3.noarch.rpm 
warning: Expected size:        17306 = lead(96)+sigs(344)+pad(0)+data(16866)
warning:   Actual size:        17285
error: xmlto-0.0.10-3.noarch.rpm: No signature available
error: query of xmlto-0.0.10-3.noarch.rpm failed

However, on Valhalla (and with the RPM version that is the latest for Valhalla)
the same repackaged rpms can be queried without problems. Makes me believe there
is some problem here either in Limbo's version of RPM or Valhalla's version of
RPM. You choose.

How reproducible:

Steps to Reproduce:
1. Install Limbo.
2. Run up2date -u to upgrade.
3. rpm -qpl /var/spool/up2date/glibc-common-2.2.90-14.i386.rpm 
where "glibc-common-2.2.90-14.i386.rpm" is the repackaged glibc-common from
Limbo, not the new one from RHN (which is -15).

Actual Results:  

warning: Expected size:     11486008 = lead(96)+sigs(344)+pad(0)+data(11485568)
warning:   Actual size:      5485639
error: glibc-common-2.2.90-14.i386.rpm: No signature available
error: query of glibc-common-2.2.90-14.i386.rpm failed

Expected Results:  The contents of the package.
Comment 1 Aleksey Nogin 2002-07-22 19:04:57 EDT
*** Bug 69519 has been marked as a duplicate of this bug. ***
Comment 2 Aleksey Nogin 2002-07-22 19:14:01 EDT
This does not seem to be up2date specific (just doing rpm -e --repackage causes
the same thing to happen), so I've updated the "Summary" line.
Comment 3 Jeff Johnson 2002-07-25 18:49:56 EDT
Fixed in rpm-4.1-0.57. There were 2 forms of breakage:
	1) payload was generated with only base names.
	2) the legacy size check prevented the signature
	header from being returned.

Note carefully that a package reconstituted with --repackage
will always have a different size, as there's an RPMTAG_REMOVETID
tag appended to the header. There are several other causes
of size change as well, particularly if the files from the
package are deleted and/or missing.

Note You need to log in before you can comment on or make changes to this bug.